# for SQLite

CREATE TABLE 'spanish_word' (
  'id' INTEGER PRIMARY KEY AUTOINCREMENT,
  'type' INTEGER,
  'word' TEXT
);
create unique index sw_id_index on spanish_word (id);
create unique index sw_word_index on spanish_word (word);


CREATE TABLE 'spanish_verb_conjugation' (
  'id' INTEGER PRIMARY KEY AUTOINCREMENT,
  'word_id' INTEGER,
  'tense' INTEGER,
  'person' INTEGER,
  'conjugation' TEXT
);
create index svc_conjugation_index on spanish_verb_conjugation (conjugation);
create index svc_word_id_index on spanish_verb_conjugation (word_id);


CREATE TABLE 'english_word' (
  'id' INTEGER PRIMARY KEY AUTOINCREMENT,
  'type' INTEGER,
  'word' TEXT
);
create unique index ew_id_index on spanish_word (id);
create unique index ew_word_index on spanish_word (word);


CREATE TABLE 'spanish_english' (
  'id' INTEGER PRIMARY KEY AUTOINCREMENT,
  'spanish_word_id' INTEGER,
  'english_word_id' INTEGER
);
create index se_spanish_id_index on spanish_english (spanish_word_id);
create index se_english_id_index on spanish_english (english_word_id);
