 ###############################################################################
 #  Copyright 2008 Ian McIntosh <ian@openanswers.org>
 #
 #  This program is free software; you can redistribute it and/or modify
 #  it under the terms of the GNU General Public License as published by
 #  the Free Software Foundation; either version 2 of the License, or
 #  (at your option) any later version.
 #
 #  This program is distributed in the hope that it will be useful,
 #  but WITHOUT ANY WARRANTY; without even the implied warranty of
 #  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 #  GNU Library General Public License for more details.
 #
 #  You should have received a copy of the GNU General Public License
 #  along with this program; if not, write to the Free Software
 #  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 ###############################################################################

class GladeWindow
	# pretend we are actually the window by redirecting calls (e.g., "show") to the root widget
	def method_missing(aSymbol, *args)
		@window.send(aSymbol, *args) if @window.respond_to?(aSymbol)
	end

=begin
	def invoke_before_filter(name)
		# stop processing if one returns 'false'
		if @before_filters[name]
			for filter_name in @before_filters[name]
				if send(filter_name) == false
					return false
				end
			end
		end
		return true
	end

	def invoke_after_filter(name)
		@after_filters[name].each { |filter_name| send filter_name } if @after_filters[name]
	end

	def before_filter(filter_name, options)
		options[:only].each { |meth| @before_filters[meth] ||= []; @before_filters[meth] << filter_name; } if options[:only]
	end

	def after_filter(filter_name, options)
		options[:only].each { |meth| @after_filters[meth] ||= []; @after_filters[meth] << filter_name; } if options[:only]
	end
=end

	def initialize(root_widget_name)
		@hide_window_on_escape = true		# set these 'false' in the subclass to override
		@remove_urgency_on_focus = true
		#@before_filters = {}
		#@after_filters = {}

		#meth = Proc.new { on_delete_event }

		# load the widgets below 'root_widget' and auto-hookup all the methods
		glade = GladeXML.new(GLADE_FILE_NAME, root_widget_name) { | handler_name |
			method(handler_name)
			#Proc.new { invoke_before_filter(handler_name) && self.send(handler_name) ; invoke_after_filter(handler_name); }
		}

		# create instance variables for each widget below us
   	glade.widget_names.each { |name| instance_variable_set('@' + name, glade.get_widget(name)) unless name == root_widget_name }

		# in the class, we will refer to the GtkWindow as @window when referencing variables
		puts root_widget_name
		@window = glade.get_widget(root_widget_name)

		# setup some default responses to events
		@window.signal_connect('delete_event') { self.on_delete_event }
		#@window.signal_connect('focus_in_event') { @window.urgency_hint = false if @remove_urgency_on_focus }
		#@window.signal_connect('key_press_event') { |o,e| self.on_key_press_event(o,e) }

		#
		# Add helpful automatic behaviors
		#
		#@close_button.signal_connect('clicked') { @window.hide } if @close_button.nil? == false	# a widget named "close_button" hides window

		#glade.widget_names.each { |name|
			## BEHAVIOR: a checkbutton "X_checkbutton" automatically enables/disables widget "X_dependent"
			#if name =~ (/\A(.*?)_checkbutton\Z/) && instance_variable_get('@' +  name + '_dependent') != nil
				#instance_variable_get('@' + name).signal_connect('toggled') {instance_variable_get('@' + name + '_dependent').sensitive = instance_variable_get('@' + name).active? }
			#end
		#}
	end

	# signal handlers
	def on_delete_event
		hide if @hide_window_on_escape
	end

	def on_key_press_event(widget, event)
		case event.keyval
			when Gdk::Keyval::GDK_Escape then if @hide_window_on_escape then hide; return true; end
		end
		return false	# default is to allow further processing of this event
	end
end
