 ###############################################################################
 #  Copyright 2008 Ian McIntosh <ian@openanswers.org>
 #
 #  This program is free software; you can redistribute it and/or modify
 #  it under the terms of the GNU General Public License as published by
 #  the Free Software Foundation; either version 2 of the License, or
 #  (at your option) any later version.
 #
 #  This program is distributed in the hope that it will be useful,
 #  but WITHOUT ANY WARRANTY; without even the implied warranty of
 #  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 #  GNU Library General Public License for more details.
 #
 #  You should have received a copy of the GNU General Public License
 #  along with this program; if not, write to the Free Software
 #  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 ###############################################################################

class History
	def initialize
		@list = []
		@index = -1
	end

	def add(item)
		@index += 1
		@list[@index] = item
		@list = @list.first(@index+1)	# chop off all history after this index
	end

	def can_go_back
		return @index > 0
	end

	def can_go_forward
		return @index < (@list.size - 1);
	end

	def back
		@index -= 1 if can_go_back
	end

	def forward
		@index += 1 if  can_go_forward
	end

	def current
		@list[ @index ]
	end
end
